<script setup>
import {onMounted, ref} from "vue";
import {adminFlushCache, getUserData, isLogged, myAlert, myQrCode, reloadToken} from "@/common/ServerAPI.js";
import router from "@/router/index.js";
import {QRCode, QRErrorCorrectLevel} from "@/common/qrcode.js";

onMounted(() => {
  if (isLogged()) {
    getUserData(basicData => {
      user.value = JSON.parse(basicData);
    });
  }
});

const user = ref(null);
const showSettings = ref(false);
const qrCodeCanvas = ref(null);
const qrCodeGenerated = ref(false);

function verifyTelegram() {
  myAlert("Le site est encore en construction")
}

function editTelegram() {
  myAlert("Le site est encore en construction")
}

function verifyDiscord() {
  myAlert("Le site est encore en construction")
}

function editDiscord() {
  myAlert("Le site est encore en construction")
}

function editPersonalMail() {
  myAlert("Le site est encore en construction")
}

function verifyPersonalMail() {
  myAlert("Le site est encore en construction")
}

function editEpflMail() {
  myAlert("Le site est encore en construction")
}

function verifyEpflMail() {
  myAlert("Le site est encore en construction")
}

function logout() {
  localStorage.clear();
  reloadToken();
  router.push("/login");
  myAlert("Vous avez bien été déconnecté ✅");
}

function flushCache() {
  adminFlushCache(() => myAlert("Opération effectuée ✅"));
}

function showQRCode() {
  myQrCode(code => {
    const QRCodeVersion = 5;
    const canvas = qrCodeCanvas.value;
    const ctx = canvas.getContext('2d');
    let qr = null;
    try {
      qr = new QRCode(QRCodeVersion, QRErrorCorrectLevel.M);
      qr.addData(code);
      qr.make();
    } catch (err) {
      console.log(err);
      myAlert("La génération du QRCode a échoué !");
      return;
    }

    const qrSize = qr.getModuleCount();
    const scale = 10;
    canvas.width = qrSize * scale;
    canvas.height = qrSize * scale;

    ctx.fillStyle = "#d3a589";
    ctx.fillRect(0, 0, qrSize * scale, qrSize * scale);
    for (let r = 0; r < qrSize; r++) {
      for (let c = 0; c < qrSize; c++) {
        if (qr.isDark(r, c)) {
          ctx.fillStyle = "#33355a";
        } else {
          ctx.fillStyle = "#d3a589";
        }
        ctx.fillRect(c * scale, r * scale, scale, scale);
      }
    }
    qrCodeGenerated.value = true;
  });
}

</script>
<template>
  <ul
      class="flex flex-col text-center text-sm font-medium text-white mb-4 md:mt-20">
    <li class="text-2xl font-extrabold  max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4 mb-12">
      Bonjour {{ user?.firstName + " " + user?.lastName }}
    </li>
    <li>
      <button
          @click="showSettings = !showSettings"
          class="mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        Paramètres du compte
      </button>
    </li>
    <li v-if="showSettings">
      <div
          class="mb-4 inline-flex items-center px-4 py-3 text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        <svg class="w-4 h-4 me-2 text-black" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor"
             viewBox="0 0 20 20">
          <path
              d="M10 0a10 10 0 1 0 10 10A10.011 10.011 0 0 0 10 0Zm0 5a3 3 0 1 1 0 6 3 3 0 0 1 0-6Zm0 13a8.949 8.949 0 0 1-4.951-1.488A3.987 3.987 0 0 1 9 13h2a3.987 3.987 0 0 1 3.951 3.512A8.949 8.949 0 0 1 10 18Z"/>
        </svg>
        Mail personnel :
        <a :href="'mailto:'+user?.personalMail?.value" class="underline pl-1"
           style="color: blue">{{ user?.personalMail?.value }}</a>
        <div class="flex-auto text-right">
          <span v-if="user?.verifiedPersonalMail">Vérifié ✅</span>
          <span v-if="!user?.verifiedPersonalMail">Non vérifié ❌</span>
          <button type="button"
                  class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm ml-2 px-2 py-1 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                  @click="verifyPersonalMail()" v-if="!user?.verifiedPersonalMail">Vérifier
          </button>
          <button type="button"
                  class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm ml-2 px-2 py-1 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                  @click="editPersonalMail()">Modifier
          </button>
        </div>
      </div>
    </li>
    <li v-if="showSettings">
      <div
          class="mb-4 inline-flex items-center px-4 py-3 text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        <svg class="w-4 h-4 me-2 text-black" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor"
             viewBox="0 0 20 20">
          <path
              d="M10 0a10 10 0 1 0 10 10A10.011 10.011 0 0 0 10 0Zm0 5a3 3 0 1 1 0 6 3 3 0 0 1 0-6Zm0 13a8.949 8.949 0 0 1-4.951-1.488A3.987 3.987 0 0 1 9 13h2a3.987 3.987 0 0 1 3.951 3.512A8.949 8.949 0 0 1 10 18Z"/>
        </svg>
        Mail EPFL :
        <a :href="'mailto:'+user?.epflMail?.value" class="underline pl-1"
           style="color: blue">{{ user?.epflMail?.value }}</a>
        <div class="flex-auto text-right">
          <span v-if="user?.verifiedEpflMail">Vérifié ✅</span>
          <span v-if="!user?.verifiedEpflMail">Non vérifié ❌</span>
          <button type="button"
                  class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm ml-2 px-2 py-1 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                  @click="verifyEpflMail()" v-if="!user?.verifiedEpflMail">Vérifier
          </button>
          <button type="button"
                  class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm ml-2 px-2 py-1 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                  @click="editEpflMail()">Modifier
          </button>
        </div>
      </div>
    </li>
    <li v-if="showSettings">
      <div
          class="mb-4 inline-flex items-center px-4 py-3 text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        <svg class="w-4 h-4 me-2 text-black" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor"
             viewBox="0 0 20 20">
          <path
              d="M10 0a10 10 0 1 0 10 10A10.011 10.011 0 0 0 10 0Zm0 5a3 3 0 1 1 0 6 3 3 0 0 1 0-6Zm0 13a8.949 8.949 0 0 1-4.951-1.488A3.987 3.987 0 0 1 9 13h2a3.987 3.987 0 0 1 3.951 3.512A8.949 8.949 0 0 1 10 18Z"/>
        </svg>
        Telegram :
        <a :href="'https://t.me/'+user?.telegramUsername?.value.slice(1)" class="underline pl-1"
           style="color: blue">{{ user?.telegramUsername?.value }}</a>
        <div class="flex-auto text-right">
          <span v-if="user?.verifiedTelegram">Vérifié ✅</span>
          <span v-if="!user?.verifiedTelegram">Non vérifié ❌</span>
          <button type="button"
                  class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm ml-2 px-2 py-1 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                  @click="verifyTelegram()" v-if="!user?.verifiedTelegram">Vérifier
          </button>
          <button type="button"
                  class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm ml-2 px-2 py-1 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                  @click="editTelegram()">Modifier
          </button>
        </div>
      </div>
    </li>
    <li v-if="showSettings">
      <div
          class="mb-4 inline-flex items-center px-4 py-3 text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        <svg class="w-4 h-4 me-2 text-black" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor"
             viewBox="0 0 20 20">
          <path
              d="M10 0a10 10 0 1 0 10 10A10.011 10.011 0 0 0 10 0Zm0 5a3 3 0 1 1 0 6 3 3 0 0 1 0-6Zm0 13a8.949 8.949 0 0 1-4.951-1.488A3.987 3.987 0 0 1 9 13h2a3.987 3.987 0 0 1 3.951 3.512A8.949 8.949 0 0 1 10 18Z"/>
        </svg>
        Discord :
        <span class="pl-1">{{ user?.discordUsername?.value }}</span>
        <div class="flex-auto text-right">
          <span v-if="user?.verifiedDiscord">Vérifié ✅</span>
          <span v-if="!user?.verifiedDiscord">Non vérifié ❌</span>
          <button type="button"
                  class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm ml-2 px-2 py-1 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                  @click="verifyDiscord()" v-if="!user?.verifiedDiscord">Vérifier
          </button>
          <button type="button"
                  class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm ml-2 px-2 py-1 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                  @click="editDiscord()">Modifier
          </button>
        </div>
      </div>
    </li>

    <li v-if="showSettings">
      <div
          class="mb-4 inline-flex items-center px-4 py-3 text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        <svg class="w-4 h-4 me-2 text-black" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor"
             viewBox="0 0 20 20">
          <path
              d="M10 0a10 10 0 1 0 10 10A10.011 10.011 0 0 0 10 0Zm0 5a3 3 0 1 1 0 6 3 3 0 0 1 0-6Zm0 13a8.949 8.949 0 0 1-4.951-1.488A3.987 3.987 0 0 1 9 13h2a3.987 3.987 0 0 1 3.951 3.512A8.949 8.949 0 0 1 10 18Z"/>
        </svg>
        Vos roles :
        <span class="pl-1" v-for="role in user.roles">{{ role }}</span>
      </div>
    </li>
    <li v-if="showSettings">
      <button
          @click="logout"
          class="mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        Se déconnecter
      </button>
    </li>
    <!--      <h2 class="text-2xl font-extrabold  max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4 mb-12"-->
    <!--          v-if="courseName">Espace RC ({{ courseName }})</h2>-->
    <!--      <li v-if="courseName">-->
    <!--        <RouterLink to="/rc/staff"-->
    <!--                    class="inline-flex items-center px-4 py-3 text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center"-->
    <!--                    aria-current="page">-->
    <!--          <svg class="w-4 h-4 me-2 text-black" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor"-->
    <!--               viewBox="0 0 20 20">-->
    <!--            <path-->
    <!--                d="M10 0a10 10 0 1 0 10 10A10.011 10.011 0 0 0 10 0Zm0 5a3 3 0 1 1 0 6 3 3 0 0 1 0-6Zm0 13a8.949 8.949 0 0 1-4.951-1.488A3.987 3.987 0 0 1 9 13h2a3.987 3.987 0 0 1 3.951 3.512A8.949 8.949 0 0 1 10 18Z"/>-->
    <!--          </svg>-->
    <!--          Recrutement des staffs-->
    <!--        </RouterLink>-->
    <!--      </li>-->
    <!--      <li v-if="courseName">-->
    <!--        <RouterLink to="/rc/archives"-->
    <!--                    class="inline-flex items-center px-4 py-3 rounded-lg bg-s4s-purple-800 hover:bg-gray-100 w-full lg:max-w-[30%] flex-center"-->
    <!--                    aria-current="page">-->
    <!--          <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5"-->
    <!--               stroke="currentColor" class="w-4 h-4 me-2 text-white">-->
    <!--            <path stroke-linecap="round" stroke-linejoin="round"-->
    <!--                  d="M19.5 14.25v-2.625a3.375 3.375 0 0 0-3.375-3.375h-1.5A1.125 1.125 0 0 1 13.5 7.125v-1.5a3.375 3.375 0 0 0-3.375-3.375H8.25m5.231 13.481L15 17.25m-4.5-15H5.625c-.621 0-1.125.504-1.125 1.125v16.5c0 .621.504 1.125 1.125 1.125h12.75c.621 0 1.125-.504 1.125-1.125V11.25a9 9 0 0 0-9-9Zm3.75 11.625a2.625 2.625 0 1 1-5.25 0 2.625 2.625 0 0 1 5.25 0Z"/>-->
    <!--          </svg>-->

    <!--          Archives du cours (Page en construction)-->
    <!--        </RouterLink>-->
    <!--      </li>-->
    <!--      <li v-if="courseName">-->
    <!--        <RouterLink to="/rc/rooms"-->
    <!--                    class="inline-flex items-center px-4 py-3 rounded-lg hover:text-gray-900 bg-s4s-purple-800 hover:bg-gray-100 w-full    lg:max-w-[30%] flex-center"-->
    <!--                    aria-current="page">-->
    <!--          <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5"-->
    <!--               stroke="currentColor" class="w-4 h-4 me-2 text-gray-500 ">-->
    <!--            <path stroke-linecap="round" stroke-linejoin="round" d="M15 10.5a3 3 0 1 1-6 0 3 3 0 0 1 6 0Z"/>-->
    <!--            <path stroke-linecap="round" stroke-linejoin="round"-->
    <!--                  d="M19.5 10.5c0 7.142-7.5 11.25-7.5 11.25S4.5 17.642 4.5 10.5a7.5 7.5 0 1 1 15 0Z"/>-->
    <!--          </svg>-->
    <!--          Salles (Page en construction)-->
    <!--        </RouterLink>-->
    <!--      </li>-->
    <!--      <li>-->
    <!--        <a href="about:blank"-->
    <!--           class="inline-flex items-center px-4 py-3 rounded-lg hover:text-gray-900 bg-s4s-purple-800 hover:bg-gray-100 w-full    lg:max-w-[30%] flex-center"-->
    <!--           aria-current="page">-->
    <!--          <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5"-->
    <!--               stroke="currentColor" class="w-4 h-4 me-2 text-gray-500 ">-->
    <!--            <path stroke-linecap="round" stroke-linejoin="round"-->
    <!--                  d="M20.25 8.511c.884.284 1.5 1.128 1.5 2.097v4.286c0 1.136-.847 2.1-1.98 2.193-.34.027-.68.052-1.02.072v3.091l-3-3c-1.354 0-2.694-.055-4.02-.163a2.115 2.115 0 0 1-.825-.242m9.345-8.334a2.126 2.126 0 0 0-.476-.095 48.64 48.64 0 0 0-8.048 0c-1.131.094-1.976 1.057-1.976 2.192v4.286c0 .837.46 1.58 1.155 1.951m9.345-8.334V6.637c0-1.621-1.152-3.026-2.76-3.235A48.455 48.455 0 0 0 11.25 3c-2.115 0-4.198.137-6.24.402-1.608.209-2.76 1.614-2.76 3.235v6.226c0 1.621 1.152 3.026 2.76 3.235.577.075 1.157.14 1.74.194V21l4.155-4.155"/>-->
    <!--          </svg>-->
    <!--          Serveur Discord-->
    <!--        </a>-->
    <!--      </li>-->

    <h2 class="text-2xl font-extrabold  max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4 mb-12"
        v-if="user && user.roles.includes('rol_week_participant_2024')">Vous êtes participant à l'édition 2024 d'S4S
      !</h2>
    <li v-if="user && user.roles.includes('rol_week_participant_2024') && !qrCodeGenerated">
      <button
          @click="showQRCode"
          class="mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        QRCode d'accès
      </button>
    </li>
    <li>
      <canvas ref="qrCodeCanvas"
              :style="qrCodeGenerated ? 'visibility: visible' : 'visibility: hidden; height: 0'"
              class="inline mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
      </canvas>
    </li>
    <li v-if="user && user.roles.includes('rol_week_participant_2024')">
      <router-link type="button" to="/workshops"
                   class="inline-block mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        Inscription workshops
      </router-link>
    </li>

    <h2 class="text-2xl font-extrabold  max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4 mb-12"
        v-if="user && user.roles.includes('rol_board_2024')">Espace Comité</h2>
    <li v-if="user && user.roles.includes('rol_board_2024')">
      <router-link type="button" to="/qrcode"
                   class="inline-block mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        Scan des QRCodes d'accès
      </router-link>
    </li>


    <h2 class="text-2xl font-extrabold  max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4 mb-12"
        v-if="user && user.roles.includes('rol_admin')">Espace Admin</h2>
    <li v-if="user && user.roles.includes('rol_admin')">
      <button
          @click="flushCache"
          class="mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        Flush Cache
      </button>
    </li>

    <li>
      <a type="button" href="https://go.epfl.ch/s4s-drive-2024"
         class="inline-block mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        Drive S4S
      </a>
    </li>

    <li>
      <a type="button" href="https://t.me/Students4Students2024"
         class="inline-block mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        Groupe Telegram
      </a>
    </li>

  </ul>
</template>
